migrate_from_trac.rake does not convert timestamps in Trac database version 23
Status: New Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Importers Estimated time: 0.00 hour

Target version:    

Description

In Trac API 0.12, the representation of timestamps was changed from seconds since the epoch

to microseconds since the epoch:

http://trac.edgewall.org/wiki/TracDev/ApiChanges/0.12#Timestampstorageindatabase

See this patch that changed it in Trac:

http://trac.edgewall.org/attachment/ticket/6466/6466-microsecond-times-r8770.patch

If you try to run the existing migrate_from_trac.rake script, the year will be thousands

of years in the future, and the importer will populate the date in redmine is 0000000000.

This causes many things to break.

The problem still exists with the trunk version of the migrate_from_trac.rake script.

In #882 , the user encountered the problem, but went down the wrong path with the fix,

because he didn't understand why timestamps were being imported incorrectly.

I am submitting a better fix, which detects the database version of Trac.  If the database

version is > 22, then every time a timestamp from Trac is encountered, we divide by 1 million.

This patch is against trunk.

I have used this patch successfully and it fixes all my problems importing from Trac.

I think many people are hitting these issues when doing Trac -> Redmine migrations.  Here are some example tickets:

#5764

#8690

#12477

Related issues:

Related to Redmine - Patch #5764: migrate_from_trac does not support trac 0.12 New 2010-06-27

Related to Redmine - Defect #8690: User can't be displayed Needs feedback2011-06-27

Related to Redmine - Defect #12477: Internal server error after migrate from ... Needs feedback

Related to Redmine - Defect #14590: migrate_from_trac.rake does not import Tr... Closed

Related to Redmine - Patch #14592: migrate_from_trac.rake does not properly p... Closed

Related to Redmine - Patch #14593: migrate_from_trac.rake, print out validati... New

Related to Redmine - Defect #14844: migrate_from_trac is not run in database ... New

Related to Redmine - Defect #6868: migrate_from_trac and trac 0.12 Reopened 2010-11-11

Related to Redmine - Defect #10738: trac import issue New

Related to Redmine - Defect #20943: migrate_from_trac.rake dont work Resolved

Has duplicate Redmine - Defect #14845: Error in user controller Closed

Has duplicate Redmine - Defect #17898: Exception in Migration from Trac to Re... Closed

History

#1 - 2013-07-31 11:15 - Toshi MARUYAMA

- Description updated

#2 - 2013-07-31 11:16 - Toshi MARUYAMA

- Description updated
#3 - 2013-07-31 11:16 - Toshi MARUYAMA

- Related to Patch #5764: migrate_from_trac does not support trac 0.12 added

#4 - 2013-07-31 11:16 - Toshi MARUYAMA

- Related to Defect #8690: User can't be displayed added

#5 - 2013-07-31 11:17 - Toshi MARUYAMA

- Related to Defect #12477: Internal server error after migrate from Trac 0.12.3 ro Redmine 2 added

#6 - 2013-08-01 09:19 - Toshi MARUYAMA

- Related to Defect #14590: migrate_from_trac.rake does not import Trac users, uses too short password added

#7 - 2013-08-01 09:55 - Toshi MARUYAMA

- Related to Patch #14592: migrate_from_trac.rake does not properly parse First Name and Last Name added

#8 - 2013-08-01 09:56 - Toshi MARUYAMA

- Related to Patch #14593: migrate_from_trac.rake, print out validation errors when doing save added

#9 - 2013-09-05 15:01 - Etienne Massip

- Related to Defect #14845: Error in user controller added

#10 - 2013-09-05 15:01 - Etienne Massip

- Related to deleted (Defect #14845: Error in user controller)

#11 - 2013-09-05 15:01 - Etienne Massip

- Has duplicate Defect #14845: Error in user controller added

#12 - 2013-09-14 23:18 - Craig Rodrigues

I have a copy of migrate_from_trac.rake in a Github fork, where I am preserving the patches:

https://github.com/rodrigc/redmine/blob/master/lib/tasks/migrate_from_trac.rake

Hopefully my patches can be incorporated into Redmine, so that I don't have to keep my own

private copy.  This will benefit others who are trying to migrate to Redmine from Trac.

#13 - 2013-09-14 23:21 - Craig Rodrigues

I used these patches to migrate about 3000 Trac tickets to Redmine.  See:

FreeNAS project migration from Trac to Redmine

#14 - 2013-10-07 15:31 - Marc Schlaich

Craig, could you please have a look at #14844? Would be great if this could be fixed in this patch. Shouldn't be too hard but I have no Ruby

experience else I would do it on my own.

#15 - 2013-10-08 04:01 - Craig Rodrigues

Marc,

I'll see what I can do, but can't promise anything.  My main reasons for fixing the

migrate_from_trac.rake script to do the following:

FreeNAS project migration from Trac to Redmine

However, since I have finished that, I can't devote a lot more time to Remdmine, but I will try if I have time.

I would encourage you to take a whack at learning Ruby and trying to fix this script.

I didn't know Ruby before fixing migrate_from_trac.rake but I learned enough to get going.

The code in Redmine is very clean, so it is easy to pick up.

The code in Redmine which accesses the database is part of the ActiveRecord class in Rails.  ActiveRecord

has an API for doing transactions:

http://api.rubyonrails.org/classes/ActiveRecord/Transactions.html
Give it a shot and see if you can get something working, and I can review it.

#16 - 2013-10-09 02:56 - Toshi MARUYAMA

- Related to Defect #14844: migrate_from_trac is not run in database transaction added

#17 - 2013-10-19 14:11 - Toshi MARUYAMA

- Related to Defect #6868: migrate_from_trac and trac 0.12 added

#18 - 2013-10-19 14:11 - Toshi MARUYAMA

- Related to Defect #10738: trac import issue added

#19 - 2014-10-16 13:02 - Toshi MARUYAMA

- Has duplicate Defect #17898: Exception in Migration from Trac to Redmine (incl. solution) added

#20 - 2015-11-05 05:31 - Toshi MARUYAMA

- Related to Defect #20943: migrate_from_trac.rake dont work added

Files

migrate_from_trac.rake.patch.txt 5.31 KB 2013-07-29 Craig Rodrigues
